unit Mainform;

interface

uses
	RakBinaryStreamdata, RakDestroy,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls;

type
  TFrmMain = class(TForm)
    PageControl1: TPageControl;
    TbsSimple: TTabSheet;
    BtnSave: TButton;
    BtnLoad: TButton;
    TabSheet1: TTabSheet;
    Label1: TLabel;
    EdtSimpleFileName: TEdit;
    BtnSaveSimple: TButton;
    BtnLoadSimple: TButton;
    TabSheet2: TTabSheet;
    Label2: TLabel;
    EdtHideFileName: TEdit;
    BtnSaveHide: TButton;
    BtnLoadHide: TButton;
    TabSheet3: TTabSheet;
    Label3: TLabel;
    EdtOOFileName: TEdit;
    BtnSaveOO: TButton;
    BtnLoadOO: TButton;
    procedure BtnSaveClick(Sender: TObject);
    procedure BtnLoadClick(Sender: TObject);
    procedure BtnSaveSimpleClick(Sender: TObject);
    procedure BtnLoadSimpleClick(Sender: TObject);
    procedure BtnSaveHideClick(Sender: TObject);
    procedure BtnLoadHideClick(Sender: TObject);
    procedure BtnSaveOOClick(Sender: TObject);
    procedure BtnLoadOOClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

  TOOTestClass = class;

  TOOTestClassReadWriteHandler = class(TRakBinaryReadWrite)
  private
  	Owner: TOOTestClass;
  public
    procedure AfterReadFromProperties(Tag: TRakBinaryTag); override;
    procedure AfterWriteToProperties(Tag: TRakBinaryTag); override;

    procedure BeforeReadFromSimpleProperty(var PropertyDescription: TRakBinaryReadFromSimplePropertyDescription); override;

    procedure BeforeWriteToSimpleProperty(var PropertyDescription: TRakBinaryWriteToSimplePropertyDescription); override;
    procedure AttributForSimplePropertyNotFound(PropertyDescription: TRakBinaryWriteToSimplePropertyDescription); override;
  end;


{$M+}
  TSimpleTestClass = class
  private
    FWert1: integer;
    FWert2: string;
  published
  	property Wert1: integer read FWert1 write FWert1;
    property Wert2: string read FWert2 write FWert2;
  end;

  TOOTestClass = class(TSimpleTestClass, IRakBinaryReadFrom, IRakBinaryWriteTo)
  private
  	FHandler: IUnknown;
    FReadWriteHandler: TOOTestClassReadWriteHandler;

    FEigenerWert: extended;
  protected
    property ReadWriteHandler: TOOTestClassReadWriteHandler read FReadWriteHandler write FReadWriteHandler implements IRakBinaryReadFrom, IRakBinaryWriteTo;
  public
  	constructor Create;

    property EigenerWert: extended read FEigenerWert write FEigenerWert;
  end;
{$M-}

var
  FrmMain: TFrmMain;

implementation

{$R *.DFM}

type
	TTestEnum = (te1, te2, te3);
  TTestSet = set of TTestEnum;

{$M+}
  TAClass = class(TObject, IRakBinaryReadFrom, IRakBinaryWriteTo)
  private
    FasWert: AnsiString;
    FiWert: integer;

    FReadFrom: IRakBinaryReadFrom;
    FWriteTo: IRakBinaryWriteTo;
  protected
    property ReadFrom: IRakBinaryReadFrom read FReadFrom write FReadFrom implements IRakBinaryReadFrom;
    property WriteTo: IRakBinaryWriteTo read FWriteTo write FWriteTo implements IRakBinaryWriteTo;
  public
  	constructor Create;
  published
  	property iWert: integer read FiWert write FiWert;
  	property asWert: AnsiString read FasWert write FasWert;
  end;

  TAReadFrom = class(TRakBinaryReadFrom)
  private
  	Owner: TAClass;
  public
    procedure BeforeReadFromSimpleProperty(var PropertyDescription: TRakBinaryReadFromSimplePropertyDescription); override;
  end;

  TAWriteTo = class(TRakBinaryWriteTo)
  private
  	Owner: TAClass;
  public
    procedure BeforeWriteToSimpleProperty(var PropertyDescription: TRakBinaryWriteToSimplePropertyDescription); override;
    procedure AttributForSimplePropertyNotFound(PropertyDescription: TRakBinaryWriteToSimplePropertyDescription); override;
  end;

	TDummyClass = class
  private
    FSubClass: TAClass;
  public
  	constructor Create;
    destructor Destroy; override;
  published
    property SubClass: TAClass read FSubClass write FSubClass;
  end;

	TSubClass = class
  private
  	FiWert: integer;
    FfWert: extended;
    FSubClass: TSubClass;
  public
    destructor Destroy; override;
  published
  	property iWert: integer read FiWert write FiWert;
  	property fWert: extended read FfWert write FfWert;
    property SubClass: TSubClass read FSubClass write FSubClass;
  end;

  TTestClass = class
  private
  	FiWert: integer;
    FfWert: extended;
    FbWert: boolean;
    FasWert: AnsiString;
    FssWert: ShortString;
    FenumWert: TTestEnum;
    FsetWert: TTestSet;
    FwsWert: WideString;
    FcWert: char;
    FwcWert: WideChar;
    FSubClass: TSubClass;
    FDummyClass: TDummyClass;
  public
  	constructor Create;
    destructor Destroy; override;
  published
  	property iWert: integer read FiWert write FiWert;
  	property fWert: extended read FfWert write FfWert;
  	property bWert: boolean read FbWert write FbWert;
  	property asWert: AnsiString read FasWert write FasWert;
  	property ssWert: ShortString read FssWert write FssWert;
  	property wsWert: WideString read FwsWert write FwsWert;
  	property enumWert: TTestEnum read FenumWert write FenumWert;
  	property setWert: TTestSet read FsetWert write FsetWert;
  	property cWert: char read FcWert write FcWert;
  	property wcWert: WideChar read FwcWert write FwcWert;
    property SubClass: TSubClass read FSubClass write FSubClass;
    property DummyClass: TDummyClass read FDummyClass write FDummyClass;
  end;

{$M-}

procedure TFrmMain.BtnSaveClick(Sender: TObject);
var
	Data: TRakBinaryStreamData;
  Test: TTestClass;
  Options: IRakBinaryReadFromPropertiesOptions;
  SimpleProp: IRakBinaryReadFromSimpleProperty;
  ClassProp: IRakBinaryReadFromClassProperty;
begin
  Test := TTestClass.Create;
	Data := TRakBinaryStreamData.Create;
  try
  	// Das zu speichernde Objekt mit Werten versorgen
  	Test.iWert := 15;
  	Test.fWert := 13.13;
  	Test.bWert := true;
  	Test.asWert := 'bluber';
  	Test.ssWert := 'blub';
  	Test.wsWert := 'aus is';
  	Test.enumWert := te2;
  	Test.setWert := [te2, te3];
    Test.cWert := 'p';
    Test.wcWert := '';

    Test.SubClass.iWert := 99;
    Test.SubClass.fWert := 12.5;

    Test.SubClass.SubClass.iWert := 456456;
    Test.SubClass.SubClass.fWert := -3e12;

    Test.DummyClass.SubClass.iWert := 50;
    Test.DummyClass.SubClass.asWert := 'dummy';

    // Hinweis: Die diversen Gro-/Kleinschreibefehler wurden bewusst gemacht, um zu testen
    // ob die Properties trotzdem gefunden werden

    // Das Defaulverhalten durchbrechen
  	Options := TRakBinaryReadFromPropertiesOptions.Create;
    // Property iWert soll nicht mit gespeichert werden
    SimpleProp := Options.AddSimpleProperty;
    SimpleProp.PropertyName := 'iwert';
    SimpleProp.AttributName := '';
    // Property fWert soll unter dem Namen 'xyz' gespeichert werden
    SimpleProp := Options.AddSimpleProperty;
    SimpleProp.PropertyName := 'FWERT';
    SimpleProp.AttributName := 'xyz';

    // SubClass soll unter dem Tag 'Unterobjekt' gespeichert werden
    ClassProp := Options.AddClassProperty;
    ClassProp.PropertyName := 'subClass';
    ClassProp.TagName := 'Unterobjekt';
    // Property SubClass.iWert soll nicht gespeichert werden
    SimpleProp := ClassProp.Options.AddSimpleProperty;
    SimpleProp.PropertyName := 'iwert';
    SimpleProp.AttributName := '';
    // Das Unterobjekt soll gespeichert werden
    ClassProp.ReadFromClassAttributs := true;

    // Testen, ob wir ihn beim Laden durcheinander bringen knnen, wenn es die genderten
    // Attribute trotzdem gibt
    TRakBinaryLongint.AddToTag(Data, 'iWert', 12);
    TRakBinaryExtended.AddToTag(Data, 'fWert', 12);

    // Testen ob das Umbenennen des Subtags funktioniert, indem sonst eine Namenskollision auftritt
    Data.AddTag('SUBCLASS');

    // Die Properties des Objekts in Data bernehmen
		Data.ReadFromPublishedProperties(Test, Options, true);
    // und auf der Festplatte speichern
    Data.SaveToFile('f:\temp\testclass.dat');
  finally
    Data.Free;
    Test.Free;
  end;
end;

procedure TFrmMain.BtnLoadClick(Sender: TObject);
var
	Data: TRakBinaryStreamData;
  Test: TTestClass;
  Options: IRakBinaryWriteToPropertiesOptions;
  SimpleProp: IRakBinaryWriteToSimpleProperty;
  ClassProp: IRakBinaryWriteToClassProperty;
begin
  Test := TTestClass.Create;
	Data := TRakBinaryStreamData.Create;
  try
    // Hinweis: Die diversen Gro-/Kleinschreibefehler wurden bewusst gemacht, um zu testen
    // ob die Properties trotzdem gefunden werden

  	// Das Defaultverhalten wurde beim Speichern gendert. Daran mssen wir uns beim
    // Einlesen anpassen
	  Options := TRakBinaryWriteToPropertiesOptions.Create;
    // Property iWert soll nicht mit gespeichert werden
    SimpleProp := Options.AddSimpleProperty;
    SimpleProp.PropertyName := 'iwert';
    SimpleProp.AttributName := '';
    // Property fWert soll unter dem Namen 'xyz' gespeichert werden
    SimpleProp := Options.AddSimpleProperty;
    SimpleProp.PropertyName := 'FWERT';
    SimpleProp.AttributName := 'xyz';

    // SubClass soll unter dem Tag 'Unterobjekt' gespeichert werden
    ClassProp := Options.AddClassProperty;
    ClassProp.PropertyName := 'subclass';
    ClassProp.TagName := 'unterobjekt';
    // Property SubClass.iWert soll nicht gespeichert werden
    SimpleProp := ClassProp.Options.AddSimpleProperty;
    SimpleProp.PropertyName := 'iwert';
    SimpleProp.AttributName := '';


  	// Die gespeicherten Werte von der Festplatte in Data einlesen
  	Data.LoadFromFile('f:\temp\testclass.dat');
    // Die Properties des Objektes mit den eingelesenen Werten versorgen
		Data.WriteToPublishedProperties(Test, Options);


    // Prfen, ob alles richtig eingelesen wurde
  	if (Test.iWert = 0) and (Test.fWert = 13.13) and (Test.bWert = true)
  		and (Test.asWert = 'bluber') and (Test.ssWert = 'blub') and (Test.wsWert = 'aus is')
  		and (Test.enumWert = te2) and (Test.setWert = [te2, te3])
    	and (Test.cWert = 'p') and (Test.wcWert = '')
    	and (Test.SubClass.iWert = 0) and (Test.SubClass.fWert = 12.5)
    	and (Test.SubClass.SubClass.iWert = 456456) and (Test.SubClass.SubClass.fWert = -3e12)
    	and (Test.DummyClass.SubClass.iWert = 0) and (Test.DummyClass.SubClass.asWert = 'dummy')
      then
    begin
	    ShowMessage('yeah');
    end
    else
    begin
	    ShowMessage('mist');
    end;

  finally
    Data.Free;
    Test.Free;
  end;
end;

{ TAClass }

constructor TAClass.Create;
var
  rf: TAReadFrom;
  wt: TAWriteTo;
begin
	inherited;

  rf := TAReadFrom.Create;
  rf.Owner := self;

  wt := TAWriteTo.Create;
  wt.Owner := self;

  FReadFrom := rf;
  FWriteTo := wt;
end;

{ TDummyClass }

constructor TDummyClass.Create;
begin
	inherited;

  FSubClass := TAClass.Create;
end;

destructor TDummyClass.Destroy;
begin
	FSubClass.Free;

  inherited;
end;

{ TTestClass }

constructor TTestClass.Create;
begin
	inherited;
  SubClass := TSubClass.Create;
  SubClass.SubClass := TSubClass.Create;
  DummyClass := TDummyClass.Create;
end;

destructor TTestClass.Destroy;
begin
	SubClass.Free;
  DummyClass.Free;

  inherited;
end;

{ TSubClass }

destructor TSubClass.Destroy;
begin
	SubClass.Free;

  inherited;
end;

{ TAReadFrom }

procedure TAReadFrom.BeforeReadFromSimpleProperty(
  var PropertyDescription: TRakBinaryReadFromSimplePropertyDescription);
begin
	// iWert soll nicht gespeichert werden.
  if CompareText(PropertyDescription.PropertyName, 'iWert') = 0 then
  	PropertyDescription.AttributName := ''
	// asWert soll unter dem Namen 's' gespeichert werden.
  else if CompareText(PropertyDescription.PropertyName, 'asWert') = 0 then
  	PropertyDescription.AttributName := 's';
end;

{ TAWriteTo }

procedure TAWriteTo.AttributForSimplePropertyNotFound(
  PropertyDescription: TRakBinaryWriteToSimplePropertyDescription);
begin
	// Defaultwerte setzen
  if CompareText(PropertyDescription.PropertyName, 'iWert') = 0 then
  	Owner.iWert := 0
  else if CompareText(PropertyDescription.PropertyName, 'asWert') = 0 then
  	Owner.asWert := '';
end;

procedure TAWriteTo.BeforeWriteToSimpleProperty(
  var PropertyDescription: TRakBinaryWriteToSimplePropertyDescription);
begin
	// iWert soll nicht versorgt werden.
  if CompareText(PropertyDescription.PropertyName, 'iWert') = 0 then
  	PropertyDescription.AttributName := ''
	// asWert soll aus dem Attribut 's' versorgt werden.
  else if CompareText(PropertyDescription.PropertyName, 'asWert') = 0 then
  	PropertyDescription.AttributName := 's';
end;

procedure TFrmMain.BtnSaveSimpleClick(Sender: TObject);
var
	Obj: TSimpleTestClass;
begin
	Obj := TSimpleTestClass.Create;
  try
		Obj.Wert1 := 5;
    Obj.Wert2 := 'test';
    TRakBinaryStreamData.SaveObjectToFile(Obj, EdtSimpleFileName.Text);
  finally
  	Obj.Free
  end;
end;

{ TSimpleTestClass }

procedure TFrmMain.BtnLoadSimpleClick(Sender: TObject);
var
	Obj: TSimpleTestClass;
begin
	Obj := TSimpleTestClass.Create;
  try
    TRakBinaryStreamData.LoadObjectFromFile(Obj, EdtSimpleFileName.Text);

		ShowMessage('Wert1=' + IntToStr(Obj.Wert1));
		ShowMessage('Wert2=' + Obj.Wert2);
  finally
  	Obj.Free
  end;
end;

procedure TFrmMain.BtnSaveHideClick(Sender: TObject);
var
	Obj: TSimpleTestClass;
  Data: TRakBinaryStreamData;
  Options: IRakBinaryReadFromPropertiesOptions;
  SimpleProp: IRakBinaryReadFromSimpleProperty;
begin
	Obj := TSimpleTestClass.Create;
  Data := TRakBinaryStreamData.Create;
  try
		Obj.Wert1 := 5;
    Obj.Wert2 := 'test';

    Options := TRakBinaryReadFromPropertiesOptions.Create;
    // Property Wert1 soll nicht mit gespeichert werden
    SimpleProp := Options.AddSimpleProperty;
    SimpleProp.PropertyName := 'Wert1';
    SimpleProp.AttributName := '';
    // Property Wert2 soll unter dem Namen 's' gespeichert werden,
    SimpleProp := Options.AddSimpleProperty;
    SimpleProp.PropertyName := 'Wert2';
    SimpleProp.AttributName := 's';
    // da wir unter dem Namen Wert2 einen ganz anderen Wert speichern wollen
    TRakBinaryExtended.AddToTag(Data, 'Wert2', 111);

    Data.ReadFromPublishedProperties(Obj, Options);
    Data.SaveToFile(EdtHideFileName.Text);
  finally
  	Obj.Free;
    Data.Free;
  end;
end;

procedure TFrmMain.BtnLoadHideClick(Sender: TObject);
var
	Obj: TSimpleTestClass;
  Data: TRakBinaryStreamData;
  Options: IRakBinaryWriteToPropertiesOptions;
  SimpleProp: IRakBinaryWriteToSimpleProperty;
begin
	Obj := TSimpleTestClass.Create;
  Data := TRakBinaryStreamData.Create;
  try
    Data.LoadFromFile(EdtHideFileName.Text);

    Options := TRakBinaryWriteToPropertiesOptions.Create;
    // Property Wert2 wurde unter dem Namen 's' gespeichert
    SimpleProp := Options.AddSimpleProperty;
    SimpleProp.PropertyName := 'Wert2';
    SimpleProp.AttributName := 's';

    Data.WriteToPublishedProperties(Obj, Options);

		ShowMessage('Wert1=' + IntToStr(Obj.Wert1));
		ShowMessage('Wert2=' + Obj.Wert2);
    ShowMessage('Eigener Wert=' + FloatToStr(Data.AttributeAsFloat('Wert2', 0)));
  finally
  	Obj.Free;
    Data.Free;
  end;
end;

{ TOOTestClass }

constructor TOOTestClass.Create;
begin
	inherited;

	FEigenerWert := 30;

  FReadWriteHandler := TOOTestClassReadWriteHandler.Create;
  FReadWriteHandler.Owner := self;
  FHandler := FReadWriteHandler;
end;

{ TOOTestClassReadWriteHandler }

procedure TOOTestClassReadWriteHandler.AfterReadFromProperties(
  Tag: TRakBinaryTag);
begin
  TRakBinaryExtended.AddToTag(Tag, 'Wert2', Owner.FEigenerWert);
end;

procedure TOOTestClassReadWriteHandler.AfterWriteToProperties(
  Tag: TRakBinaryTag);
begin
  Owner.FEigenerWert := Tag.AttributeAsFloat('Wert2', 0);
end;

procedure TOOTestClassReadWriteHandler.AttributForSimplePropertyNotFound(
  PropertyDescription: TRakBinaryWriteToSimplePropertyDescription);
begin
  if CompareText(PropertyDescription.PropertyName, 'Wert2') = 0 then
  	Owner.Wert2 := '';
end;

procedure TOOTestClassReadWriteHandler.BeforeReadFromSimpleProperty(
  var PropertyDescription: TRakBinaryReadFromSimplePropertyDescription);
begin
  if CompareText(PropertyDescription.PropertyName, 'Wert1') = 0 then
  	PropertyDescription.AttributName := ''
  else if CompareText(PropertyDescription.PropertyName, 'Wert2') = 0 then
  	PropertyDescription.AttributName := 's';
end;

procedure TOOTestClassReadWriteHandler.BeforeWriteToSimpleProperty(
  var PropertyDescription: TRakBinaryWriteToSimplePropertyDescription);
begin
  if CompareText(PropertyDescription.PropertyName, 'Wert1') = 0 then
  	PropertyDescription.AttributName := ''
  else if CompareText(PropertyDescription.PropertyName, 'Wert2') = 0 then
  	PropertyDescription.AttributName := 's';
end;

procedure TFrmMain.BtnSaveOOClick(Sender: TObject);
var
	Obj: TOOTestClass;
begin
	Obj := TOOTestClass.Create;
  try
		Obj.Wert1 := 5;
    Obj.Wert2 := 'test';
    TRakBinaryStreamData.SaveObjectToFile(Obj, EdtOOFileName.Text);
  finally
  	Obj.Free
  end;
end;

procedure TFrmMain.BtnLoadOOClick(Sender: TObject);
var
	Obj: TOOTestClass;
begin
	Obj := TOOTestClass.Create;
  try
    TRakBinaryStreamData.LoadObjectFromFile(Obj, EdtOOFileName.Text);

		ShowMessage('Wert1=' + IntToStr(Obj.Wert1));
		ShowMessage('Wert2=' + Obj.Wert2);
		ShowMessage('EigenerWert=' + FloatToStr(Obj.EigenerWert));
  finally
  	Obj.Free
  end;
end;

end.
